Imports Microsoft.VisualBasic
Imports System
Imports System.ComponentModel
Imports System.Windows.Forms
Imports Syncfusion.Windows.Forms.Diagram
Imports Syncfusion.Windows.Forms.Diagram.Controls
Imports Syncfusion.Windows.Forms.Tools
Public Class Form1

    Public Sub New()
        '
        ' Required for Windows Form Designer support
        '
        InitializeComponent()

        Me.Diagram1.Model = Me.Model1
        Me.Diagram1.View.Grid.GridStyle = GridStyle.Line
        Me.Diagram1.View.Grid.Color = System.Drawing.Color.LightBlue
        Me.Diagram1.View.Grid.HorizontalSpacing = 12
        Me.Diagram1.View.Grid.VerticalSpacing = 12

        '
        ' TODO: Add any constructor code after InitializeComponent call
        '

        ' Load Palette
        'Me.pgvTables.LoadPalette("..\..\Test Symbols.edp")
        Me.pgvTables.LoadPalette("..\..\Tables.edp")
    End Sub


    Private Sub Form1_RotationChanged(ByVal evtArgs As RotationChangedEventArgs)

        lbRot.Text = evtArgs.NodeAffected.RotationAngle.ToString()

        evtArgs.NodeAffected.RotationAngle = Get45Rotation(evtArgs.NodeAffected.RotationAngle)

    End Sub

    Private Function Get45Rotation(ByVal theRotation As Integer) As Integer
        Dim RetVal As Integer = 0
        If theRotation <= 45 Then
            RetVal = 0
        ElseIf theRotation <= 90 Then
            RetVal = 90
        ElseIf theRotation <= 90 + 45 Then
            RetVal = 90
        ElseIf theRotation <= 180 Then
            RetVal = 180
        ElseIf theRotation <= 180 + 45 Then
            RetVal = 180
        ElseIf theRotation <= 270 Then
            RetVal = 270
        Else
            RetVal = 0
        End If
        Return RetVal
    End Function


    <EventHandlerPriority(True)> _
Private Sub EventSink_NodeCollectionChanged(ByVal evtArgs As CollectionExEventArgs)
        If Me.diagram1.View.SelectionList.Count <> 0 Then
            'Me.propertyEditor.SetSelectedObjects(Me.diagram1.View.SelectionList)
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        AddHandler (CType(Model1.EventSink, DocumentEventSink)).RotationChanged, AddressOf Form1_RotationChanged
    End Sub

    Private Sub butSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butSave.Click
        Me.Diagram1.SaveBinary("..\..\test.edd")
    End Sub


    Private Sub butLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butLoad.Click


        ' I found that if I did NOT do this before the LoadBinary the Overveiw would not match the diagram
        Me.OverviewControl1.DetachDiagram()


        Me.Diagram1.LoadBinary("..\..\test.edd")

        ' This then hooked the diagram back up to the diagram
        Me.OverviewControl1.Diagram = Me.Diagram1

        If Not Me.Diagram1.Model Is Nothing Then
            Me.Diagram1.Invalidate(True)
        End If


        ' I found that if I did this line of code I would end up with a blank
        ' diagram, although the overview was still showing the loaded diagram.
        ' Uncomment to see what I'm talking about.

        'Diagram1.Model = Me.Model1



    End Sub

End Class
